# CSC 111, Practice Final, Part 4 Solution
# Author: Sara Mathieson
# Create a "guess my number" game using classes.


import random


class GameHost:

    def __init__(self, low, high):
        """Constructor: choose a random number between low and high."""
        self.answer = random.randint(low, high)
        self.is_guessed = False
        self.num_tries = 0

    def get_is_guessed(self):
        """Return whether or not the user has guessed the number."""
        return self.is_guessed

    def try_guess(self, number):
        """The user guesses number and we check if it's correct."""
        self.num_tries += 1 # increment the number of guesses

        # user guessed correctly
        if self.answer == number:
            print(number, "is correct! You took", self.num_tries,"tries.")
            self.is_guessed = True # flip boolean

        # user gussed incorrectly
        else:
            print(number,"is wrong! Guess again.")
 

def main():
    """Test out our GameHost class: keep guessing until we get it right."""
    low, high = 1, 10
    host = GameHost(low, high) # use constructor

    # guess until we get it right
    while not host.get_is_guessed():
        number = random.randint(low,high) # pick a random guess
        host.try_guess(number) # process the guess
        

main()
